"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var https = require('follow-redirects').https;
var AdmZip = require("adm-zip");
var shelljs = require("shelljs");
var path = require("path");
var fs = require("fs");
var config_1 = require("./config");
var GaugeDownloader = (function () {
    function GaugeDownloader() {
    }
    Object.defineProperty(GaugeDownloader.prototype, "url", {
        get: function () {
            if (this.os === 'linux') {
                return config_1.options.GAUGE_URL_TEMPLATE_LINUX
                    .replace('%GAUGE_VERSION%', config_1.options.GAUGE_VERSION)
                    .replace('%GAUGE_VERSION%', config_1.options.GAUGE_VERSION)
                    .replace('%ARCH_STRING%', this.arch);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GaugeDownloader.prototype, "arch", {
        get: function () {
            var arch = process.arch;
            if (arch === 'x64') {
                return 'x86_64';
            }
            else {
                return 'x86';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GaugeDownloader.prototype, "os", {
        get: function () {
            return process.platform;
        },
        enumerable: true,
        configurable: true
    });
    GaugeDownloader.prototype.setupGauge = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (!fs.existsSync(config_1.options.CACHE_FOLDER)) {
                    console.log('CREATING FOLDER .gauge');
                    shelljs.mkdir('-p', config_1.options.CACHE_FOLDER);
                }
                return [2 /*return*/, this.download()
                        .then(this.unzipGauge.bind(this))
                        .then(this.copyConfig.bind(this))
                        .then(this.giveExecutionPermission.bind(this))
                        .then(this.installGaugeJsPlugin.bind(this))
                        .then(this.installGaugeHtmlReportPlugin.bind(this))];
            });
        });
    };
    GaugeDownloader.prototype.giveExecutionPermission = function () {
        return new Promise(function (resolve, reject) {
            try {
                shelljs.chmod('+x', config_1.options.GAUGE_BINARY);
                shelljs.chmod('+x', config_1.options.GAUGE_SCREENSHOT_BINARY);
                resolve();
            }
            catch (e) {
                reject(e);
            }
        });
    };
    GaugeDownloader.prototype.copyConfig = function () {
        shelljs.mkdir('-p', config_1.options.GAUGE_HOME_CONFIG);
        shelljs.cp('-R', config_1.options.GAUGE_CONFIG + '/*', config_1.options.GAUGE_HOME_CONFIG);
        return Promise.resolve();
    };
    GaugeDownloader.prototype.installGaugeJsPlugin = function () {
        return new Promise(function (resolve, reject) {
            shelljs.exec(config_1.options.GAUGE_BINARY + " --install js", {
                async: true,
                env: {
                    GAUGE_HOME: config_1.options.GAUGE_HOME,
                    GAUGE_ROOT: config_1.options.GAUGE_BINARY_FOLDER
                },
            }, function (code, stdout, stderr) {
                if (code === 0) {
                    resolve();
                }
                else {
                    reject(new Error('code: ' + stderr));
                }
            });
        });
    };
    GaugeDownloader.prototype.installGaugeHtmlReportPlugin = function () {
        return new Promise(function (resolve, reject) {
            shelljs.exec(config_1.options.GAUGE_BINARY + " --install html-report", {
                async: true,
                env: {
                    GAUGE_HOME: config_1.options.GAUGE_HOME,
                    GAUGE_ROOT: config_1.options.GAUGE_BINARY_FOLDER
                },
            }, function (code, stdout, stderr) {
                if (code === 0) {
                    resolve();
                }
                else {
                    reject(new Error('code: ' + stderr));
                }
            });
        });
    };
    GaugeDownloader.prototype.unzipGauge = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var admZip = new AdmZip(_this.gaugeDownloadedFile);
            admZip.extractAllToAsync(config_1.options.GAUGE_BINARY_FOLDER, true, function (error) {
                if (error) {
                    reject(error);
                }
                else {
                    resolve();
                }
            });
        });
    };
    GaugeDownloader.prototype.download = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            fs.exists(_this.gaugeDownloadedFile, function (exists) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!exists) return [3 /*break*/, 1];
                            resolve();
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, this.execute_download()];
                        case 2:
                            _a.sent();
                            resolve();
                            _a.label = 3;
                        case 3: return [2 /*return*/];
                    }
                });
            }); });
        });
    };
    Object.defineProperty(GaugeDownloader.prototype, "gaugeDownloadedFile", {
        get: function () {
            return path.join(config_1.options.CACHE_FOLDER, "gauge-" + config_1.options.GAUGE_VERSION + ".zip");
        },
        enumerable: true,
        configurable: true
    });
    GaugeDownloader.prototype.execute_download = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        console.log("starting the gauge download [ " + _this.url + " ]... ");
                        var req = https.get(_this.url, function (res) {
                            if (res.statusCode === 200) {
                                var file = fs.createWriteStream(_this.gaugeDownloadedFile);
                                res.pipe(file);
                                res.on('end', function () {
                                    resolve(_this.gaugeDownloadedFile);
                                });
                            }
                            else {
                                console.error("Error.... status code: " + res.statusCode);
                                reject(new Error("Error downloading gauge, Status Code: " + res.statusCode));
                            }
                        });
                        req.end();
                        req.on('error', function (e) {
                            reject(e);
                        });
                    })];
            });
        });
    };
    return GaugeDownloader;
}());
exports.GaugeDownloader = GaugeDownloader;
