"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var shelljs = require("shelljs");
var figlet = require("figlet");
var chalk = require("chalk");
var inquirer = require("inquirer");
var path = require("path");
var config_1 = require("./config");
var validate = require("validate-npm-package-name");
var packageJSON = require(path.join(process.cwd(), 'package.json'));
console.log(chalk.yellow(figlet.textSync('Gauge Setup ®')));
console.log(chalk.blue("author: Abner Oliveira <abner.silva@gmail.com>"));
function askProjectType() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, inquirer.prompt([{
                        name: "project_type",
                        type: "list",
                        message: "Choose your Gauge Project type:",
                        choices: [{ value: "ts-web-steps", name: "Typescript with Web Steps" }, { value: "js", name: "Simple Javascript" }]
                    }])];
        });
    });
}
function getProjectName() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    inquirer.prompt([{
                            name: 'project_name',
                            type: 'input',
                            message: 'Enter your gauge project name',
                            default: 'gauge-specs-for-' + packageJSON.name,
                            validate: function (input) {
                                var validateResult = validate(input);
                                if (validateResult.errors) {
                                    console.error(validateResult.errors.join('\n'));
                                }
                                return validateResult.validForNewPackages;
                            }
                        }]).then(function (answer) {
                        resolve(answer.project_name);
                    }).catch(function (e) { return reject(e.message); });
                })];
        });
    });
}
(function () {
    return __awaiter(this, void 0, void 0, function () {
        var answerProjectType, e_1, e_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 5, , 6]);
                    shelljs.config.silent = false;
                    answerProjectType = void 0;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, askProjectType()];
                case 2:
                    answerProjectType = _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _a.sent();
                    answerProjectType = { project_type: 'js' };
                    return [3 /*break*/, 4];
                case 4:
                    console.log('ANSWER: ', answerProjectType['project_type']);
                    // fs.writeFileSync(options.GAUGE_ROOT_FOLDER)
                    console.log('\nCreating project folder...');
                    shelljs.mkdir(config_1.options.GAUGE_PROJECT_FOLDER);
                    console.log('\nCopying template files...');
                    shelljs.cp('-Rf', "" + path.join(__dirname, '..', "__templates__/" + answerProjectType['project_type'] + "/*"), config_1.options.GAUGE_PROJECT_FOLDER);
                    console.log('\nAdding gauge scritps to package.json file on host project ...');
                    return [3 /*break*/, 6];
                case 5:
                    e_2 = _a.sent();
                    console.error('No Project Name defined.');
                    process.exit(1);
                    return [3 /*break*/, 6];
                case 6: return [2 /*return*/];
            }
        });
    });
})();
